Subject: bug#66554: [PATCH] Add the public API of Compat to the core

From: Daniel Mendler <[email-masked]>
Date: Fri, 12 Jan 2024 19:40:38 +0100

Eli Zaretskii <[email-masked]> writes:

>> From: Philip Kaludercic <[email-masked]>
>> Cc: [email-masked],  [email-masked],
>>   [email-masked],  [email-masked]
>> Date: Fri, 12 Jan 2024 18:17:21 +0000
>> 
>> Eli Zaretskii <[email-masked]> writes:
>> 
>> >> From: Philip Kaludercic <[email-masked]>
>> >> Cc: [email-masked],  [email-masked],  Stefan Monnier
>> >>  <[email-masked]>,  Stefan Kangas <[email-masked]>
>> >> Date: Fri, 12 Jan 2024 16:29:15 +0000
>> >> 
>> >> > What happens when we bump Emacs version from NN.x to NN.x.90 or from
>> >> > NN.x.90 to NN.x.91?  emacs-major-version and emacs-minor-version stay
>> >> > the same, but the Emacs version is bumped, and there could be changes
>> >> > in compat.el specific to the next release, NN.x+1 or NN+1.1, no?
>> >> 
>> >> Generally speaking, Compat only provides support for "proper" releases,
>> >> and not for pre-releases.
>> >
>> > Is that wise?
>> >
>> > Can't we support pretest versions as well?
>> 
>> I hope I am not misunderstanding something, but from the perspective of
>> Compat and Emacs development as a whole, I think it would be preferable
>> to not start propagating additions and changes to functions that might
>> change before a proper release, so as to not unnecessarily burden
>> development with sticking to decisions that one realises were mistakes
>> before the final release is cut.
>
> I guess I'm misunderstanding something.  The scenario that I have in
> mind is this:
>
>   . we bump Emacs version to NN.1.90 as part of pretesting version NN.2
>   . as part of the pretest, some function changes that requires
>     addition or change in compat.el
>   . compat.el still claims version NN.1, although it includes changes
>     not present in Emacs NN.1
>
> Did I succeed in explaining my worries?

I hope I understood your reasoning correctly. Shortly after you bump
NN.1.90 we can release compat-NN.2.0 which will include the necessary
change. This Compat version will be installed on Emacs with version NN.1
but not on the upcoming Emacs NN.2.

Daniel